package xyz.lychee.lagfixer.libs.adventure.text.minimessage.internal.parser.match;

import xyz.lychee.lagfixer.libs.adventure.text.minimessage.internal.parser.TokenType;
import xyz.lychee.lagfixer.libs.annotations.MustBeInvokedByOverriders;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.UnknownNullability;

public abstract class MatchedTokenConsumer<T> {
   protected final String input;
   private int lastIndex = -1;

   public MatchedTokenConsumer(final @NotNull String input) {
      this.input = input;
   }

   @MustBeInvokedByOverriders
   public void accept(final int start, final int end, final @NotNull TokenType tokenType) {
      this.lastIndex = end;
   }

   public abstract @UnknownNullability T result();

   public final int lastEndIndex() {
      return this.lastIndex;
   }
}
